%define releasebase 5
%define nbase lapack
%define lnbase  lapack
%define bnbase  blas
%define lprefix /opt/lapack/%{version}
%define bprefix /opt/blas/%{version}

#Use as deafults if no command line inputs
%define as_limulus 1
# NOTE: compilers are mutually exclusive, only set one,
#       if not using command line options
#       !not all compilers have been implemented and tested!
%define use_gnu4  1
%define use_gnu3 0
%define use_pgi  0
%define use_intel 0
%define use_pathsc 0
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif



Summary: The LAPACK libraries for numerical linear algebra.
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
Version: 3.1.0
License: Freely distributable
URL: http://www.netlib.org/lapack/
Packager: deadline@basement-supercomputing.com
Vendor: Basement Supercomputing.com
Source: %{nbase}-%{version}.tgz
Source2: make.inc.pgi-%{version}
Source3: make.inc.gnu3-%{version}
Source4: make.inc.gnu4-%{version}
Patch0:  lapack-etime.patch
Patch1:  lapack-dsecnd.patch


BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: modules

# is there a better way to do this?
%if "1" == "%{use_pgi}"
Name: %{lnbase}-pgi
%define bname  %{bnbase}-pgi
%define lbuildprefix %{lprefix}/pgi
%define bbuildprefix %{bprefix}/pgi
%define modprefix pgi
%define fcompiler pg77
%define fcompiler-opts
%define ccompiler pgcc
%else
%if "1" == "%{use_intel}"
Name: %{lnbase}-intel
%define bname  %{bnbase}-intel
%define lbuildprefix %{lprefix}/intel
%define bbuildprefix %{bprefix}/intel
%define modprefix intel
%else
%if "1" == "%{use_pathsc}"
Name: %{lnbase}-pathsc
%define bname  %{bnbase}-pathsc
%define modprefix pathsc
%define lbuildprefix %{lprefix}/path
%define bbuildprefix %{bprefix}/path
%else
%if "1" == "%{use_gnu4}"
Name: %{lnbase}-gnu4
%define bname  %{bnbase}-gnu4
%define modprefix gnu4
%define lbuildprefix %{lprefix}/gnu4
%define bbuildprefix %{bprefix}/gnu4
%define buildprefix %{prefix}/gnu4
%define fcompiler gfortran
%define fcompiler_opts_static "-O2"
%define fcompiler_opts_shared "-O2 -fPIC"
%define ccompiler gcc
%else
Name: %{lnbase}-gnu3
%define bname  %{bnbase}-gnu3
%define lbuildprefix %{lprefix}/gnu3
%define bbuildprefix %{bprefix}/gnu3
%define modprefix gnu3
%define fcompiler g77
%define fcompiler_opts_static "-O2"
%define fcompiler_opts_shared "-O2 -fPIC"
%define ccompiler gcc
%endif
%endif
%endif
%endif



%description
LAPACK (Linear Algebra PACKage) is a standard library for numerical
linear algebra.  LAPACK provides routines for solving systems of
simultaneous linear equations, least-squares solutions of linear
systems of equations, eigenvalue problems, and singular value
problems.  Associated matrix factorizations (LU, Cholesky, QR, SVD,
Schur, and generalized Schur) and related computations (i.e.,
reordering of Schur factorizations and estimating condition numbers)
are also included.  LAPACK can handle dense and banded matrices, but
not general sparse matrices.  Similar functionality is provided for
real and complex matrices in both single and double precision.  LAPACK
is coded in Fortran77.

%package -n %{bname}
Summary: The BLAS (Basic Linear Algebra Subprograms) library for Linux.
Group: Development/Libraries
Obsoletes: lapack-blas

%description -n %{bname}
BLAS (Basic Linear Algebra Subprograms) is a standard library for
numerical algebra.  BLAS provides a number of basic algorithms for
linear algebra. BLAS is fast and well-tested, was written in FORTRAN
77 and build with egcs. BLAS manual pages are available in the
blas-man package.


%prep
%setup -n %{nbase}-%{version}
%patch0 -p0
%patch1 -p0

cp -f $RPM_SOURCE_DIR/make.inc.%{modprefix}-%{version} make.inc
# why is this not a patch?
#FIX="zerrab.f derrab.f"
#for i in $FIX
#do
#sed 's!CHARACTER(32)!CHARACTER*32!g' TESTING/LIN/$i > TESTING/LIN/$i.tmp
#cp  TESTING/LIN/$i.tmp TESTING/LIN/$i
#done


%build
cd BLAS/SRC
make 
cd ../..
make 


%install
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{lbuildprefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{lbuildprefix}/man/man1
mkdir -p $RPM_BUILD_ROOT/%{bbuildprefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{bbuildprefix}/man/man1

cp -f blas_LINUX.a $RPM_BUILD_ROOT/%{bbuildprefix}/lib/libblas.a
cp -f blas_LINUX.a $RPM_BUILD_ROOT/%{lbuildprefix}/lib/libblas.a
cp -f lapack_LINUX.a $RPM_BUILD_ROOT/%{lbuildprefix}/lib/liblapack.a


#fix the man pages to have .1 (not .l)
cd manpages/blas/man/manl
/bin/mkdir -p $RPM_BUILD_ROOT/%{bbuildprefix}/man/man1
FIX=`ls *.l`
for i in $FIX
do
NEW=`echo $i | sed -e "s/\.l/\.1/"`
cp -f $i $RPM_BUILD_ROOT/%{bbuildprefix}/man/man1/$NEW
done
gzip -9 $RPM_BUILD_ROOT/%{bbuildprefix}/man/man1/*
cd ../../../man/manl
/bin/mkdir -p $RPM_BUILD_ROOT/%{lbuildprefix}/man/man1
FIX=`ls *.l`
for i in $FIX
do
NEW=`echo $i | sed -e "s/\.l/\.1/"`
cp -f $i $RPM_BUILD_ROOT/%{lbuildprefix}/man/man1/$NEW
done
gzip -9 $RPM_BUILD_ROOT/%{lbuildprefix}/man/man1/*



%post
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >/opt/Modules/modulefiles/lapack-%{modprefix}
#%Module1.0#######################################################################
## lapac modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing lapac-%{modprefix} version %{version}.\n"
}

module-whatis "lapack-%{modprefix} %{version}"
module-log error none

set lapackroot %{lprefix}/%{modprefix}

if [ module-info mode load ] {
	setenv LAPACK_PATH \$lapackroot/lib
        append-path MANPATH \$lapackroot/man
}
if [ module-info mode remove ] {
	unsetenv LAPACK_PATH 
        remove-path MANPATH \$lapackroot/man
}
EOF

%post  -n  %{bname}
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >/opt/Modules/modulefiles/blas-%{modprefix}
#%Module1.0#######################################################################
## blas modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing blas-%{modprefix} version %{version}.\n"
}

module-whatis "blas-%{modprefix} %{version}"
module-log error none

set blasroot %{bprefix}/%{modprefix}

if [ module-info mode load ] {
	setenv BLAS_PATH \$blasroot/lib
        append-path MANPATH \$blasroot/man
}
if [ module-info mode remove ] {
	unsetenv BLAS_PATH 
        remove-path MANPATH \$blasroot/man


}
EOF

%postun
/sbin/ldconfig 2>/dev/null
/bin/rm /opt/Modules/modulefiles/lapack-%{modprefix}
%postun -n  %{bname}
/sbin/ldconfig 2>/dev/null
/bin/rm /opt/Modules/modulefiles/blas-%{modprefix}

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README
%{lbuildprefix}

%files -n  %{bname}
%defattr(-,root,root)
%{bbuildprefix}

%changelog
